//+------------------------------------------------------------------+
//|                                                          _MA.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Victor Nicolaev"
#property link      "vinin@mail.ru"
#include <Price.mq4>

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

//---- input parameters

extern int TimeFrame=1440;
extern int LRMAPeriod= 55;
extern bool VisiableAll=false;

//---- buffers
double LRMA[];
double Y[],X[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexDrawBegin(0,0);
   SetIndexBuffer(0,LRMA);
   IndicatorShortName("LRMA("+LRMAPeriod+")");
   SetIndexLabel(0,"LRMA");

   ArrayResize(X,LRMAPeriod);
   ArrayResize(Y,LRMAPeriod);
   if (TimeFrame<Period()) TimeFrame=Period();

   return(0); 
}

int Current=-1;
bool All=false;
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   int i;
   double   y=0,SS=0;

//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (limit>1440) limit = 1440;
//---- macd counted in the 1-st buffer
   for (i = limit;i>=0;i--){
      if (NevBarTimeFrame(TimeFrame,Time[i])) Current++;
      if (Current==LRMAPeriod) {
         if (!All) All=true;
         Current=0;
      }
      X[Current]=Time[i];
      Y[Current]=Close[i];
      if (All) {LRMA[i]=fLine(X,Y);}
   }
   return(0); }// int start()
   //+------------------------------------------------------------------+

bool NevBarTimeFrame(int _TimeFrame, int _Time){
   static int PrevTime=0;
   int NevBar=iBarShift(NULL,_TimeFrame, _Time,false);
   if (iTime(NULL,_TimeFrame,NevBar)<_Time) NevBar++;
   int NevTime=iTime(NULL,_TimeFrame,NevBar);
   if (PrevTime==NevTime) return(false);
   PrevTime=NevTime;
   return(true);
}

double fLine(double X[], double Y[]){
   double   sx0=0, 
            sx1=0,   
            sx2=0;
   double   syx0=0,  
            syx1=0;
   double   d[]={0,0,0};
   double tmp;
   double MaxX=X[ArrayMaximum(X)];
   for (int i = 0; i<LRMAPeriod;i++) {
      sx0++;
      sx1+=X[i];
      sx2+=X[i]*X[i];
      syx0+=Y[i];
      syx1+=Y[i]*X[i];
   }
   d[0]=opr2(sx2,sx1,
             sx1,sx0);
   d[1]=opr2(syx1,sx1,
             syx0,sx0);
   d[2]=opr2(sx2,syx1,
             sx1,syx0);

   double a=d[1]/d[0];
   double b=d[2]/d[0];
   return(a*MaxX+b); 
} 

//  
double opr2(double a11,double a12, 
            double a21, double a22) {
   double RetVal;
   RetVal=a11*a22-a12*a21;
   return(RetVal);}

